import { ProviderClass } from '@builderbot/bot';
import { Vendor } from '@builderbot/bot/dist/provider/providerClass';
import { BotContext, BotCtxMiddlewareOptions, GlobalVendorArgs, SendOptions } from '@builderbot/bot/dist/types';
import twilio from 'twilio';

import { TwilioWebHookServer } from './server';
import { TwilioProviderMethods } from './twilioInterface';
import { ITwilioProviderOptions, TwilioRequestBody } from './types';
declare class TwilioProvider extends ProviderClass implements TwilioProviderMethods {
    http: TwilioWebHookServer;
    vendor: Vendor<twilio.Twilio>;
    globalVendorArgs: ITwilioProviderOptions & Partial<GlobalVendorArgs>;
    constructor(args: ITwilioProviderOptions & Partial<GlobalVendorArgs>);
    busEvents: () => {
        event: string;
        func: (payload: any) => void;
    }[];
    sendMedia: (number: string, message: string, mediaInput: string) => Promise<import("twilio/lib/rest/api/v2010/account/message").MessageInstance>;
    sendButtons(): Promise<void>;
    listenOnEvents: () => void;
    /**
     *
     * @param port
     * @param opts
     * @returns
     */
    initHttpServer: (port: number, opts: Pick<BotCtxMiddlewareOptions, 'blacklist'>) => void;
    sendMessage: (number: string, message: string, options?: SendOptions) => Promise<any>;
    saveFile: (ctx: Partial<TwilioRequestBody & BotContext>, options?: {
        path: string;
    }) => Promise<string>;
}
export { TwilioProvider };
//# sourceMappingURL=index.d.ts.map